/*
******************************************************************************
** PEXlib Texture Mapping Test Code 
**
** $Source: /src/rcs/Cats/XSystem/pex/txm_utility_code/param_struct.h,v $
** $Revision: 510.1 $
** $Date: 94/02/26 10:42:31 $
** $Author: hmgr $
******************************************************************************
*/

/*
 *  THIS IS A PRELIMINARY VERSION!!
 */

/*
 * PARAM_STRUCT.H -- This massive structure holds all of the necessary
 *                   information to texture map any number of textures
 *                   on to a single object.
 *
 *                   Designed by Bradley L. Saunders     Sep.  7, 1993
 */

/******************************************************************************/
/*                                                                            */
/*  (c) Copyright Hewlett-Packard Company, 1993, Fort Collins, Colorado       */
/*                                                                            */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,          */
/*  provided that the above copyright notices appear in all copies and that   */
/*  both the copyright notices and this permission notice appear in           */
/*  supporting documentation, and that the name of Hewlett-Packard not be     */
/*  used in advertising or publicity pertaining to distribution of the        */
/*  software without specific, written prior permission.                      */
/*                                                                            */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS         */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable for errors contained herein or direct, indirect,      */
/*  special, incidental or consequential damages in connection with the       */
/*  furnishing, performance or use of this software.                          */
/*                                                                            */
/******************************************************************************/

#define FASWD 0  /* Fill Area Sets With Data */
#define SOFAS 1  /* Set Of Fill Areas Sets */
#define TS    2  /* Tri Strip */
#define QM    3  /* Quad Mesh */
#define NAMESIZE 1024
#define ERRORSTRINGSIZE 1024
#define MAX_OBJS 5 /* maximum number of objects possible in one parameter file */

typedef struct
{
	int TEXTURES;   /* Total number of textures */
	int texture_indx;   /* Which texture am I working on */
        PEXStructure render_target;

/* Render Information */
	PEXOCRequestType req_type;  /* PEX request PEXOCRender ... */
	int style;
	int BFstyle;
	int reflec_model;
	int BFreflec_model;
	int culling_mode;
	PEXColorSpecifier bkgd_color;

/* Do Flags */
	int Do_Custom_Background_Color;
	int Do_CreateTM;
	int Do_Call_Coord_Utility;
	int Do_Use_Custom_View_Point;
	int Do_Use_Custom_Lights;
	int Do_Use_Depth_Cue;
	int Do_Use_Coord_Source;
	int Do_Use_Composition;
	int Do_Use_Sampling_LUT;
	int Do_Use_Binding_LUT;
	int Do_SetTMPerspectiveCorrection;
	int Do_SetTMSampleFrequency;
	int Do_SetTMResourceHints;

/* PEXExtCreateFilteredTM and PEXExtCreateFilteredTMFromWindow */
	int *domain;
	PEXExtTMDomainData *domain_data;
	PEXExtTexelArray *base_map;
	PEXExtTexelArray *alpha_map;
	int *alpha_channel_hint;
	PEXExtTexelArray **texel_array;

/* PEXExtCreateFilteredTM specific */
	int *call_create_filtered_tm;

/* PEXExtCreateFilteredTMFromWindow specific */
	int *call_create_filtered_tm_from_window;
        unsigned int *luminance_selector;
        unsigned int *alpha_selector;
	int *window_depth;

/* PEXExtCreateTMDescription */
	int *parameterization;
	PEXExtTMParameterizationData *param_data;
	int *rendering_order;

/* PEXExtTMCoord */
	unsigned int obj;
	int *pex_coord_type; /* Which kind of Coord data do I load */
	unsigned int *width;
	unsigned int *height;
        unsigned int *POLYS;
	unsigned int *POINTS;
	char object_file[NAMESIZE];  /* filename and path to the object data */
	PEXExtTMCoordData coord_data;
	unsigned int vertex_fp_data_size;
	unsigned int *vertex_att;
	unsigned int *facet_att;
	int *color_type;
        unsigned int edge_flag;
	unsigned int *count;
        unsigned int *index_count;
	PEXFacetData *facet_data;
        PEXArrayOfFacetData facet_array;
        PEXListOfVertex *vertex_list1; /* Temp */
	PEXExtListOfVertex **vertex_list;
        PEXExtArrayOfVertex *vertex_array;
        PEXArrayOfVertex vertex_array1; /* Temp */
        PEXConnectivityData **connectivity;

/* PEXExtSetTMResourceHints */
	int opt_hint;
	unsigned int opt_count;
	PEXTableIndex *priorities;

/* PEXExtSetActiveTextures */
	unsigned int number_FF_textures;
	PEXTableIndex *FF_texture_indices;

/* PEXExtSetBFActiveTextures */
	unsigned int number_BF_textures;
	PEXTableIndex *BF_texture_indices;

/* PEXExtSetPerspectiveCorrection */
	int method;

/* PEXExtSetTMSamplingFrequency */
	int frequency;

/* PEXExtFillAreaSetWithData */
	int shape_hint;
	int ignore_edges;
	int contour_hint;

/* LUTS */
	int num_binding;
        int *binding_indx;
	int *binding_info;	 
	PEXExtTMBindingEntry *binding;

	int num_coordsource;
	int *coordsource_indx;
	PEXExtTMCoordSourceEntry *coordsource;

	int num_composition;
	int *composition_indx;
	PEXExtTMCompositionEntry *composition;

	int num_sampling;
	int *sampling_indx;
	PEXExtTMSamplingEntry *sampling;

/* View Point */
	int do_perspective;
	PEXViewEntry view;
	PEXCoord2D window[2];
	double view_plane, front_plane, back_plane;
	PEXCoord prp;
	PEXNPCSubVolume viewport;
	PEXCoord view_ref_pt;
	PEXVector view_plane_normal;
	PEXVector view_up_vec;

/* Light index */
	unsigned short light_index;

/* Depth Queueing */
	PEXDepthCueEntry dcue;
}Input_Parameters;
